/* libgcc1 routines for Altera nios.
   Copyright (C) 2000 Free Software Foundation, Inc.
   Contributed by Cygnus Solutions, a Red Hat company

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free Software
Foundation; either version 2, or (at your option) any later version.

In addition to the permissions in the GNU General Public License, the Free
Software Foundation gives you unlimited permission to link the compiled
version of this file with other programs, and to distribute those programs
without any restriction coming from the use of this file.  (The General
Public License restrictions do apply in other respects; for example, they
cover modification of the file, and distribution when not linked into
another program.)

This file is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
more details.

You should have received a copy of the GNU General Public License along
with this program; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.  */

/* As a special exception, if you link this library with files compiled
   with GCC to produce an executable, this does not cause the resulting
   executable to be covered by the GNU General Public License. This
   exception does not however invalidate any other reasons why the
   executable file might be covered by the GNU General Public License.  */

#ifdef __nios16__	/* Only needed with -m16 */

#ifdef L__addsi3
	.p2align 1
	.globl __addsi3
	.type	__addsi3,@function
__addsi3:
	; start prologue
	save	%sp, -23
	; end prologue

	; Get address where to store result
	mov	%l1, %fp

	pfx	16
	ld	%l0, [%l1]

	; add low word
	mov	%g0, %i0
	add	%g0, %i2

	; add high word
	mov	%g1, %i1
	addc	%g1, %i3

	; Save result on the stack
	st	[%l0], %g0
	pfx	1
	st	[%l0], %g1

	ret
	restore
.Lfe1:
	.size	 __addsi3,.Lfe1-__addsi3
#endif	/* L_addsi3 */





#ifdef L__subsi3
	.p2align 1
	.globl __subsi3
	.type	__subsi3,@function
__subsi3:
	; start prologue
	save	%sp, -23
	; end prologue

	; Get address where to store result
	mov	%l1, %fp
        pfx     16
        ld      %l0, [%l1]

	; subtract low word
	mov	%g0, %i0
	sub	%g0, %i2

	; subtract high word
	mov	%g1, %i1
	subc	%g1, %i3

	; Save result on the stack
        st      [%l0], %g0
        pfx     1
        st      [%l0], %g1

	ret
	restore
.Lfe1:
	.size	 __subsi3,.Lfe1-__subsi3
#endif	/* L_subsi3 */


#ifdef L__subdi3
	.p2align 1
	.globl __subdi3
	.type	__subdi3,@function
__subdi3:
	; start prologue
	save	%sp, -23
	; end prologue

	; Get address where to store result
	mov	%l1, %fp
        pfx     16
        ld      %l0, [%l1]

	; arg1 in %i0-%i3
	; arg2 in %i4 %i5, %fp+46, %fp+48

        ; Get address of stack args
        pfx     %hi(46)
        movi    %l5, %lo(46)
        add     %l1, %l5

	; subtract first word
	mov	%g0, %i0
	sub	%g0, %i4

	; subtract second word
	mov	%g1, %i1
	subc	%g1, %i5

	; subtract third word
        mov     %g2, %i2
        ld      %g3, [%l1]
        subc    %g2, %g3

	; subtract fourth word
	mov	%g4, %i3
	pfx	1
	ld	%g5, [%l1]

	subc	%g4, %g5

	; Save result on the stack
        st      [%l0], %g0
        pfx     1
        st      [%l0], %g1
        pfx     2
        st      [%l0], %g2
        pfx     3
        st      [%l0], %g4

	ret
	restore
.Lfe1:
	.size	 __subdi3,.Lfe1-__subdi3
#endif	/* L_subdi3 */

#ifdef L__negsi2
	.p2align 1
	.globl __negsi2
	.type	__negsi2,@function
__negsi2:
	; start prologue
	save	%sp, -23
	; end prologue

	; Get address where to store result
	mov	%l1, %fp
        pfx     16
        ld      %l0, [%l1]

	not	%i0
	not	%i1
	addi	%i0,1
	movi	%g0,0
	addc	%i1,%g0
.L0:
	; Save result on the stack
        st      [%l0], %i0
        pfx     1
        st      [%l0], %i1

	ret
	restore
.Lfe1:
	.size	__negsi2,.Lfe1-__negsi2
#endif	/* L_negsi2 */



#ifdef L__cmpsi2
	.p2align 1
	.globl __cmpsi2
	.type	 __cmpsi2,@function
__cmpsi2:
	; start prologue
	save	%sp, -23
	; end prologue

	cmp	%i1, %i3
	blt	.L10
	nop
.L3:
	cmp	%i1, %i3
	bgt	.L11
	nop
.L4:
	cmp	%i0, %i2
	bcs	.L10
	nop
	br	.L6
	nop
.L10:
	br	.L9
	movi	%i0, 0
.L6:
	cmp	%i0, %i2
	bhi	.L11
	nop
	br	.L7
	nop
.L11:
	br	.L9
	movi	%i0, 2
.L7:
	movi	%i0, 1
.L9:
	ret
	restore
.Lfe1:
	.size	 __cmpsi2,.Lfe1-__cmpsi2
#endif	/* L_cmpsi2 */


#ifdef L__ucmpsi2
	.p2align 1
	.globl __ucmpsi2
	.type	 __ucmpsi2,@function
__ucmpsi2:
	; start prologue
	save	%sp, -23
	; end prologue

	cmp	%i1, %i3
	bcs	.L20
	nop
.L13:
	cmp	%i1, %i3
	bhi	.L21
	nop
.L14:
	cmp	%i0, %i2
	bcs	.L20
	nop
	br	.L16
	nop
.L20:
	br	.L19
	movi	%i0, 0
.L16:
	cmp	%i0, %i2
	bhi	.L21
	nop
	br	.L17
	nop
.L21:
	br	.L19
	movi	%i0, 2
.L17:
	movi	%i0, 1
.L19:
	ret
	restore
.Lfe2:
	.size	 __ucmpsi2,.Lfe2-__ucmpsi2
#endif	/* L_ucmpsi2 */
#endif	/* __nios16__ */
