#include "lib2-extra.h"

SItype
__lshrsi3 (SItype u, word_type b)
{
  SIunion w;
  word_type bm;
  SIunion uu;

  if (b == 0)
    return u;

  uu.ll = u;

  bm = (sizeof (HItype) * BITS_PER_UNIT) - b;
  if (bm <= 0)
    {
      w.s.high = 0;
      w.s.low = (UHItype)uu.s.high >> -bm;
    }
  else
    {
      UHItype carries = (UHItype)uu.s.high << bm;
      w.s.high = (UHItype)uu.s.high >> b;
      w.s.low = ((UHItype)uu.s.low >> b) | carries;
    }

  return w.ll;
}


SItype
__ashlsi3 (SItype u, word_type b)
{
  SIunion w;
  word_type bm;
  SIunion uu;

  if (b == 0)
    return u;

  uu.ll = u;

  bm = (sizeof (HItype) * BITS_PER_UNIT) - b;
  if (bm <= 0)
    {
      w.s.low = 0;
      w.s.high = (UHItype)uu.s.low << -bm;
    }
  else
    {
      UHItype carries = (UHItype)uu.s.low >> bm;
      w.s.low = (UHItype)uu.s.low << b;
      w.s.high = ((UHItype)uu.s.high << b) | carries;
    }

  return w.ll;
}


SItype
__ashrsi3 (SItype u, word_type b)
{
  SIunion w;
  word_type bm;
  SIunion uu;

  if (b == 0)
    return u;

  uu.ll = u;

  bm = (sizeof (HItype) * BITS_PER_UNIT) - b;
  if (bm <= 0)
    {
      /* w.s.high = 1..1 or 0..0 */
      w.s.high = uu.s.high >> (sizeof (HItype) * BITS_PER_UNIT - 1);
      w.s.low = uu.s.high >> -bm;
    }
  else
    {
      UHItype carries = (UHItype)uu.s.high << bm;
      w.s.high = uu.s.high >> b;
      w.s.low = ((UHItype)uu.s.low >> b) | carries;
    }

  return w.ll;
}
