/* Function prototypes for the Altera Nios chip.

   Copyright (C) 1999, 2000 Free Software Foundation, Inc.
   Contributed by Cygnus Solutions, a Red Hat company

   This file is part of GNU CC.

   GNU CC is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.

   GNU CC is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.

   You should have received a copy of the GNU General Public License along
   with GNU CC; see the file COPYING.  If not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

/* Define the information needed to generate branch and scc insns.  This is
   stored from the compare operation.  Note that we can't use "rtx" here
   since it hasn't been defined. */
#ifdef RTX_CODE
extern rtx nios_compare_op0;			/* operand save for */
extern rtx nios_compare_op1;			/* comparison generation */
#endif

/* Define global data defined in nios.c */
extern int nios_branch_cost_int;		/* Branch cost */

/* Declare functions defined in nios.c */
#ifdef RTX_CODE
int nios_local_function_operand			PROTO((rtx, 
      						       enum machine_mode));
enum reg_class nios_secondary_reload_class	PROTO((enum reg_class, 
						       enum machine_mode,
						       rtx));
#endif

#ifdef TREE_CODE
#ifdef RTX_CODE
extern struct rtx_def *nios_builtin_saveregs PARAMS ((void));
extern void nios_va_start PARAMS ((int, tree, rtx));
extern struct rtx_def *nios_va_arg PARAMS ((tree, tree));
#endif
#endif

void nios_override_options			PROTO((void));
extern void nios_optimization_options		PROTO((int, int));

#ifdef RTX_CODE
extern void nios_print_operand			PROTO((FILE *, rtx, int));
extern void nios_print_operand_address		PROTO((FILE *, rtx));

#ifdef TREE_CODE
extern void nios_init_cumulative_args		PROTO((CUMULATIVE_ARGS *, tree,
						       rtx, int, int));
extern int nios_function_arg_boundary		PROTO((enum machine_mode, 
						       tree));
extern rtx nios_function_arg			PROTO((const CUMULATIVE_ARGS *,
						       enum machine_mode,
						       tree, int, int));
extern void nios_function_arg_advance		PROTO((CUMULATIVE_ARGS *,
						       enum machine_mode,
						       tree, int));
extern int nios_function_arg_partial_nregs	PROTO((CUMULATIVE_ARGS *,
						       enum machine_mode,
						       tree, int));
extern int nios_function_arg_pass_by_reference PROTO((CUMULATIVE_ARGS *,
						          enum machine_mode,
						          tree, int));
#endif	/* TREE_CODE */
#endif	/* RTX_CODE */

extern int nios_trampoline_size		PROTO((void));
extern int nios_hard_regno_mode_ok		PROTO((int, enum machine_mode));
extern int nios_modes_tieable_p		PROTO((enum machine_mode, 
						       enum machine_mode));

#ifdef RTX_CODE
extern void nios_initialize_trampoline		PROTO((rtx, rtx, rtx));
extern int nios_legitimate_constant_p		PROTO((rtx));
extern void nios_split_words			PROTO ((enum machine_mode,
							   enum machine_mode,
							   rtx *));

#ifdef TREE_CODE
extern rtx nios_return_addr_rtx		PROTO((int, rtx));
extern int nios_go_if_legitimate_address	PROTO((enum machine_mode,
						       rtx, int));
extern int nios_reg_ok_for_base_p		PROTO((rtx, int));
extern int nios_reg_ok_for_index_p		PROTO((rtx, int));
#endif	/* TREE_CODE */

extern void nios_print_int			PROTO((FILE *, rtx, int));
char *nios_output_bit_test_branch		PROTO((int, rtx, rtx *,
						       enum rtx_code));
char *nios_output_cond_branch			PROTO((int, rtx, rtx *));
char *nios_output_branch			PROTO((rtx, rtx *));
extern char *nios_output_2op_insn		PROTO((enum nios_2op_opcodes, 
						       rtx *, int, int, rtx));
extern char *nios_output_move			PROTO((rtx *, rtx));
extern char *nios_output_user_opcode		PROTO((enum nios_user_opcodes, 
						       rtx *, rtx));
extern rtx  nios_subword			PROTO((rtx, int, enum machine_mode,
						       enum machine_mode));
extern void nios_encode_label			PROTO((rtx));
#endif	/* RTX_CODE */

extern int nios_compute_frame_size 		PROTO((int, int));
extern void nios_function_prologue		PROTO((FILE *, int, int));
extern void nios_function_epilogue		PROTO((FILE *, int, int));

extern int nios_power_of_two			PROTO((HOST_WIDE_INT value));
