##==============================================================================
##
##	crt0.S
##
##	Nios startup code
##
##==============================================================================
##
## Copyright (c) 2000, Cygnus Solutions, A Red Hat Company
## 
## The authors hereby grant permission to use, copy, modify, distribute,
## and license this software and its documentation for any purpose, provided
## that existing copyright notices are retained in all copies and that this
## notice is included verbatim in any distributions. No written agreement,
## license, or royalty fee is required for any of the authorized uses.
## Modifications to this software may be copyrighted by their authors
## and need not follow the licensing terms described here, provided that
## the new terms are clearly indicated on the first page of each file where
## they apply.
##
	
##------------------------------------------------------------------------------
	
	.file	"crt0.S"

##------------------------------------------------------------------------------
## Startup code
	.section .text
	.global	_start
_start:
	pfx %hi(0xfff0)         ; initialize current window pointer to 31,
	movi %o0,%lo(0xfff0)    ; set TE to 1, IPRI to 63
	pfx 0
	wrctl %o0

	pfx %hi(_stack-8)
	movi %o0,%lo(_stack-8)	; Load up the stack pointer
#ifdef __nios32__
	pfx %xhi(_stack-8)
	movhi %o0,%xlo(_stack-8)
#endif
	mov %sp,%o0

	pfx %hi(_edata)
	movi %o0,%lo(_edata)	; Get the start/end of bss
#ifdef __nios32__
	pfx %xhi(_edata)
	movhi %o0,%xlo(_edata)
#endif
	pfx %hi(_end)
	movi %o1,%lo(_end)
#ifdef __nios32__
	pfx %xhi(_end)
	movhi %o1,%xlo(_end)
#endif
	cmp %o0,%o1		; If no bss, then do nothing
	beq .L0
	nop

	clr %r0

.L1:
	st8d [%o0],%r0		; Clear a byte and bump pointer
	inc %o0
	cmp %o0,%o1
	bne .L1
	nop

.L0:
	callc [_maina]		; Call _main to run ctors/dtors
	clr %o0
	clr %o1
	callc [maina]		; Call main program
	nop
	callc [exita]		; All done, no need to return or
				; deallocate our stack.
	nop

	.align 2
_maina:
	.nword _main@h
maina:
	.nword main@h
exita:
	.nword exit@h

	.section .stack
_stack:	.long 	1
