/* CPU family header for nios16bf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999 Free Software Foundation, Inc.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#ifndef CPU_NIOS16BF_H
#define CPU_NIOS16BF_H

/* Maximum number of instructions that are fetched at a time.
   This is for LIW type instructions sets (e.g. m32r).  */
#define MAX_LIW_INSNS 1

/* Maximum number of instructions that can be executed in parallel.  */
#define MAX_PARALLEL_INSNS 1

/* CPU state information.  */
typedef struct {
  /* Hardware elements.  */
  struct {
  /* program counter */
  USI h_pc;
#define GET_H_PC() CPU (h_pc)
#define SET_H_PC(x) (CPU (h_pc) = (x))
  /* current window pointer */
  UQI h_cwp;
#define GET_H_CWP() CPU (h_cwp)
#define SET_H_CWP(x) \
do { \
nios16bf_h_cwp_set_handler (current_cpu, (x));\
;} while (0)
  /* old window pointer */
  UQI h_old_cwp;
#define GET_H_OLD_CWP() CPU (h_old_cwp)
#define SET_H_OLD_CWP(x) (CPU (h_old_cwp) = (x))
  /* interrupt priority */
  UQI h_ipri;
#define GET_H_IPRI() CPU (h_ipri)
#define SET_H_IPRI(x) (CPU (h_ipri) = (x))
  /* enforced zero bit */
  BI h_zero[1];
#define GET_H_ZERO(a1) CPU (h_zero)[a1]
#define SET_H_ZERO(a1, x) (CPU (h_zero)[a1] = (x))
  /* trap enable bit */
  BI h_tebit;
#define GET_H_TEBIT() CPU (h_tebit)
#define SET_H_TEBIT(x) (CPU (h_tebit) = (x))
  /* negative    bit */
  BI h_nbit;
#define GET_H_NBIT() CPU (h_nbit)
#define SET_H_NBIT(x) (CPU (h_nbit) = (x))
  /* zero        bit */
  BI h_zbit;
#define GET_H_ZBIT() CPU (h_zbit)
#define SET_H_ZBIT(x) (CPU (h_zbit) = (x))
  /* overflow    bit */
  BI h_vbit;
#define GET_H_VBIT() CPU (h_vbit)
#define SET_H_VBIT(x) (CPU (h_vbit) = (x))
  /* carry       bit */
  BI h_cbit;
#define GET_H_CBIT() CPU (h_cbit)
#define SET_H_CBIT(x) (CPU (h_cbit) = (x))
  /* prefix      bit */
  BI h_pbit;
#define GET_H_PBIT() CPU (h_pbit)
#define SET_H_PBIT(x) (CPU (h_pbit) = (x))
  /* skip        bit */
  BI h_sbit;
#define GET_H_SBIT() CPU (h_sbit)
#define SET_H_SBIT(x) (CPU (h_sbit) = (x))
  /* window chg  bit */
  BI h_wbit;
#define GET_H_WBIT() CPU (h_wbit)
#define SET_H_WBIT(x) (CPU (h_wbit) = (x))
  /* status register */
  UHI h_status;
#define GET_H_STATUS() nios16bf_h_status_get_handler (current_cpu)
#define SET_H_STATUS(x) \
do { \
nios16bf_h_status_set_handler (current_cpu, (x));\
;} while (0)
  /* prefix register */
  HI h_k;
#define GET_H_K() CPU (h_k)
#define SET_H_K(x) (CPU (h_k) = (x))
  } hardware;
#define CPU_CGEN_HW(cpu) (& (cpu)->cpu_data.hardware)
} NIOS16BF_CPU_DATA;

/* Virtual regs.  */

#define GET_H_M16_GR(index) GET_H_GR_RAW (current_cpu, index)
#define SET_H_M16_GR(index, x) \
do { \
SET_H_GR_RAW (current_cpu, (index), (x));\
;} while (0)
#define GET_H_M16_GR0() GET_H_GR_RAW (current_cpu, 0)
#define SET_H_M16_GR0(x) \
do { \
SET_H_GR_RAW (current_cpu, 0, (x));\
;} while (0)
#define GET_H_M16_BP(index) GET_H_GR_RAW (current_cpu, ((index) + (16)))
#define SET_H_M16_BP(index, x) \
do { \
SET_H_GR_RAW (current_cpu, (((index)) + (16)), (x));\
;} while (0)
#define GET_H_M16_RZ(index) GET_H_GR_RAW (current_cpu, index)
#define SET_H_M16_RZ(index, x) \
do { \
SET_H_GR_RAW (current_cpu, (index), (x));\
;} while (0)
#define GET_H_M16_SP() GET_H_GR_RAW (current_cpu, 14)
#define SET_H_M16_SP(x) \
do { \
SET_H_GR_RAW (current_cpu, 14, (x));\
;} while (0)
#define GET_H_M16_CTL(index) GET_H_CTL_RAW (current_cpu, index)
#define SET_H_M16_CTL(index, x) \
do { \
SET_H_CTL_RAW (current_cpu, (index), (x));\
;} while (0)

/* Cover fns for register access.  */
USI nios16bf_h_pc_get (SIM_CPU *);
void nios16bf_h_pc_set (SIM_CPU *, USI);
UQI nios16bf_h_cwp_get (SIM_CPU *);
void nios16bf_h_cwp_set (SIM_CPU *, UQI);
UQI nios16bf_h_old_cwp_get (SIM_CPU *);
void nios16bf_h_old_cwp_set (SIM_CPU *, UQI);
UQI nios16bf_h_ipri_get (SIM_CPU *);
void nios16bf_h_ipri_set (SIM_CPU *, UQI);
BI nios16bf_h_zero_get (SIM_CPU *, UINT);
void nios16bf_h_zero_set (SIM_CPU *, UINT, BI);
BI nios16bf_h_tebit_get (SIM_CPU *);
void nios16bf_h_tebit_set (SIM_CPU *, BI);
BI nios16bf_h_nbit_get (SIM_CPU *);
void nios16bf_h_nbit_set (SIM_CPU *, BI);
BI nios16bf_h_zbit_get (SIM_CPU *);
void nios16bf_h_zbit_set (SIM_CPU *, BI);
BI nios16bf_h_vbit_get (SIM_CPU *);
void nios16bf_h_vbit_set (SIM_CPU *, BI);
BI nios16bf_h_cbit_get (SIM_CPU *);
void nios16bf_h_cbit_set (SIM_CPU *, BI);
BI nios16bf_h_pbit_get (SIM_CPU *);
void nios16bf_h_pbit_set (SIM_CPU *, BI);
BI nios16bf_h_sbit_get (SIM_CPU *);
void nios16bf_h_sbit_set (SIM_CPU *, BI);
BI nios16bf_h_wbit_get (SIM_CPU *);
void nios16bf_h_wbit_set (SIM_CPU *, BI);
UHI nios16bf_h_status_get (SIM_CPU *);
void nios16bf_h_status_set (SIM_CPU *, UHI);
HI nios16bf_h_k_get (SIM_CPU *);
void nios16bf_h_k_set (SIM_CPU *, HI);
HI nios16bf_h_m16_gr_get (SIM_CPU *, UINT);
void nios16bf_h_m16_gr_set (SIM_CPU *, UINT, HI);
HI nios16bf_h_m16_gr0_get (SIM_CPU *);
void nios16bf_h_m16_gr0_set (SIM_CPU *, HI);
HI nios16bf_h_m16_bp_get (SIM_CPU *, UINT);
void nios16bf_h_m16_bp_set (SIM_CPU *, UINT, HI);
HI nios16bf_h_m16_rz_get (SIM_CPU *, UINT);
void nios16bf_h_m16_rz_set (SIM_CPU *, UINT, HI);
HI nios16bf_h_m16_sp_get (SIM_CPU *);
void nios16bf_h_m16_sp_set (SIM_CPU *, HI);
UHI nios16bf_h_m16_ctl_get (SIM_CPU *, UINT);
void nios16bf_h_m16_ctl_set (SIM_CPU *, UINT, UHI);

/* These must be hand-written.  */
extern CPUREG_FETCH_FN nios16bf_fetch_register;
extern CPUREG_STORE_FN nios16bf_store_register;

typedef struct {
  UINT load_regs;
  UINT load_regs_pending;
} MODEL_NIOS16_1_DATA;

/* Instruction argument buffer.  */

union sem_fields {
  struct { /* no operands */
    int empty;
  } fmt_empty;
  struct { /*  */
    UINT f_i11;
  } sfmt_pfx;
  struct { /*  */
    UINT f_i4w;
  } sfmt_skps16;
  struct { /*  */
    IADDR i_m16_i8v;
  } sfmt_jmpc16;
  struct { /*  */
    IADDR i_rel11;
  } sfmt_bsr16;
  struct { /*  */
    UINT f_i8v;
  } sfmt_save16;
  struct { /*  */
    UINT f_i6v;
  } sfmt_trap16;
  struct { /*  */
    UINT f_i10;
  } sfmt_sts8s16;
  struct { /*  */
    UINT f_Ra;
    UINT f_i8;
  } sfmt_lds16;
  struct { /*  */
    IADDR i_m16_i6;
    UINT f_Ra;
  } sfmt_ldc16;
  struct { /*  */
    UINT f_Ra;
    UINT f_Rbi5;
  } sfmt_or16;
  struct { /*  */
    UINT f_Ra;
    UINT f_Rb;
  } sfmt_addc16;
  struct { /*  */
    UINT f_Ra;
    USI f_i1;
  } sfmt_ext8s16;
  struct { /*  */
    UINT f_Ra;
    UINT f_Rp;
    UINT f_i5;
  } sfmt_ldp16;
#if WITH_SCACHE_PBB
  /* Writeback handler.  */
  struct {
    /* Pointer to argbuf entry for insn whose results need writing back.  */
    const struct argbuf *abuf;
  } write;
  /* x-before handler */
  struct {
    /*const SCACHE *insns[MAX_PARALLEL_INSNS];*/
    int first_p;
  } before;
  /* x-after handler */
  struct {
    int empty;
  } after;
  /* This entry is used to terminate each pbb.  */
  struct {
    /* Number of insns in pbb.  */
    int insn_count;
    /* Next pbb to execute.  */
    SCACHE *next;
    SCACHE *branch_target;
  } chain;
#endif
};

/* The ARGBUF struct.  */
struct argbuf {
  /* These are the baseclass definitions.  */
  IADDR addr;
  const IDESC *idesc;
  char trace_p;
  char profile_p;
  /* ??? Temporary hack for skip insns.  */
  char skip_count;
  char unused;
  /* cpu specific data follows */
  union sem semantic;
  int written;
  union sem_fields fields;
};

/* A cached insn.

   ??? SCACHE used to contain more than just argbuf.  We could delete the
   type entirely and always just use ARGBUF, but for future concerns and as
   a level of abstraction it is left in.  */

struct scache {
  struct argbuf argbuf;
};

/* Macros to simplify extraction, reading and semantic code.
   These define and assign the local vars that contain the insn's fields.  */

#define EXTRACT_IFMT_EMPTY_VARS \
  unsigned int length;
#define EXTRACT_IFMT_EMPTY_CODE \
  length = 0; \

#define EXTRACT_IFMT_EXT8S16_VARS \
  UINT f_op9; \
  USI f_i1; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_EXT8S16_CODE \
  length = 2; \
  f_op9 = EXTRACT_LSB0_UINT (insn, 16, 15, 9); \
  f_i1 = ((unsigned int) (EXTRACT_LSB0_UINT (insn, 16, 6, 2)) >> (1)); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_STS8S16_VARS \
  UINT f_op6; \
  UINT f_i10; \
  unsigned int length;
#define EXTRACT_IFMT_STS8S16_CODE \
  length = 2; \
  f_op6 = EXTRACT_LSB0_UINT (insn, 16, 15, 6); \
  f_i10 = EXTRACT_LSB0_UINT (insn, 16, 9, 10); \

#define EXTRACT_IFMT_ST8D16_VARS \
  UINT f_op11; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_ST8D16_CODE \
  length = 2; \
  f_op11 = EXTRACT_LSB0_UINT (insn, 16, 15, 11); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_ADDC16_VARS \
  UINT f_op6; \
  UINT f_Rb; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_ADDC16_CODE \
  length = 2; \
  f_op6 = EXTRACT_LSB0_UINT (insn, 16, 15, 6); \
  f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_ADDI16_VARS \
  UINT f_op6; \
  UINT f_i5; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_ADDI16_CODE \
  length = 2; \
  f_op6 = EXTRACT_LSB0_UINT (insn, 16, 15, 6); \
  f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_OR16_VARS \
  UINT f_op6; \
  UINT f_Rbi5; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_OR16_CODE \
  length = 2; \
  f_op6 = EXTRACT_LSB0_UINT (insn, 16, 15, 6); \
  f_Rbi5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_LDC16_VARS \
  UINT f_op5; \
  USI f_i6_rel_h; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_LDC16_CODE \
  length = 2; \
  f_op5 = EXTRACT_LSB0_UINT (insn, 16, 15, 5); \
  f_i6_rel_h = ((((EXTRACT_LSB0_UINT (insn, 16, 10, 6)) << (1))) + (((((pc) & (131070))) + (4)))); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_LDS16_VARS \
  UINT f_op3; \
  UINT f_i8; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_LDS16_CODE \
  length = 2; \
  f_op3 = EXTRACT_LSB0_UINT (insn, 16, 15, 3); \
  f_i8 = EXTRACT_LSB0_UINT (insn, 16, 12, 8); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_LDP16_VARS \
  UINT f_op4; \
  UINT f_Rp; \
  UINT f_i5; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_LDP16_CODE \
  length = 2; \
  f_op4 = EXTRACT_LSB0_UINT (insn, 16, 15, 4); \
  f_Rp = EXTRACT_LSB0_UINT (insn, 16, 11, 2); \
  f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_TRAP16_VARS \
  UINT f_op8; \
  UINT f_o2; \
  UINT f_i6v; \
  unsigned int length;
#define EXTRACT_IFMT_TRAP16_CODE \
  length = 2; \
  f_op8 = EXTRACT_LSB0_UINT (insn, 16, 15, 8); \
  f_o2 = EXTRACT_LSB0_UINT (insn, 16, 7, 2); \
  f_i6v = EXTRACT_LSB0_UINT (insn, 16, 5, 6); \

#define EXTRACT_IFMT_SAVE16_VARS \
  UINT f_op8; \
  UINT f_i8v; \
  unsigned int length;
#define EXTRACT_IFMT_SAVE16_CODE \
  length = 2; \
  f_op8 = EXTRACT_LSB0_UINT (insn, 16, 15, 8); \
  f_i8v = EXTRACT_LSB0_UINT (insn, 16, 7, 8); \

#define EXTRACT_IFMT_RESTORE16_VARS \
  UINT f_op11; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_RESTORE16_CODE \
  length = 2; \
  f_op11 = EXTRACT_LSB0_UINT (insn, 16, 15, 11); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_BSR16_VARS \
  UINT f_op5; \
  USI f_i11_rel; \
  unsigned int length;
#define EXTRACT_IFMT_BSR16_CODE \
  length = 2; \
  f_op5 = EXTRACT_LSB0_UINT (insn, 16, 15, 5); \
  f_i11_rel = ((((((EXTRACT_LSB0_INT (insn, 16, 10, 11)) << (1))) + (pc))) + (2)); \

#define EXTRACT_IFMT_JMPC16_VARS \
  UINT f_op8; \
  USI f_i8v_rel_h; \
  unsigned int length;
#define EXTRACT_IFMT_JMPC16_CODE \
  length = 2; \
  f_op8 = EXTRACT_LSB0_UINT (insn, 16, 15, 8); \
  f_i8v_rel_h = ((((EXTRACT_LSB0_UINT (insn, 16, 7, 8)) << (1))) + (((((pc) & (131070))) + (2)))); \

#define EXTRACT_IFMT_SKPS16_VARS \
  UINT f_op11; \
  UINT f_x1; \
  UINT f_i4w; \
  unsigned int length;
#define EXTRACT_IFMT_SKPS16_CODE \
  length = 2; \
  f_op11 = EXTRACT_LSB0_UINT (insn, 16, 15, 11); \
  f_x1 = EXTRACT_LSB0_UINT (insn, 16, 4, 1); \
  f_i4w = EXTRACT_LSB0_UINT (insn, 16, 3, 4); \

#define EXTRACT_IFMT_PFX_VARS \
  UINT f_op5; \
  UINT f_i11; \
  unsigned int length;
#define EXTRACT_IFMT_PFX_CODE \
  length = 2; \
  f_op5 = EXTRACT_LSB0_UINT (insn, 16, 15, 5); \
  f_i11 = EXTRACT_LSB0_UINT (insn, 16, 10, 11); \

/* Collection of various things for the trace handler to use.  */

typedef struct trace_record {
  IADDR pc;
  /* FIXME:wip */
} TRACE_RECORD;

#endif /* CPU_NIOS16BF_H */
