/* CPU family header for nios32bf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999 Free Software Foundation, Inc.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#ifndef CPU_NIOS32BF_H
#define CPU_NIOS32BF_H

/* Maximum number of instructions that are fetched at a time.
   This is for LIW type instructions sets (e.g. m32r).  */
#define MAX_LIW_INSNS 1

/* Maximum number of instructions that can be executed in parallel.  */
#define MAX_PARALLEL_INSNS 1

/* CPU state information.  */
typedef struct {
  /* Hardware elements.  */
  struct {
  /* program counter */
  USI h_pc;
#define GET_H_PC() CPU (h_pc)
#define SET_H_PC(x) (CPU (h_pc) = (x))
  /* current window pointer */
  UQI h_cwp;
#define GET_H_CWP() CPU (h_cwp)
#define SET_H_CWP(x) \
do { \
nios32bf_h_cwp_set_handler (current_cpu, (x));\
;} while (0)
  /* old window pointer */
  UQI h_old_cwp;
#define GET_H_OLD_CWP() CPU (h_old_cwp)
#define SET_H_OLD_CWP(x) (CPU (h_old_cwp) = (x))
  /* interrupt priority */
  UQI h_ipri;
#define GET_H_IPRI() CPU (h_ipri)
#define SET_H_IPRI(x) (CPU (h_ipri) = (x))
  /* enforced zero bit */
  BI h_zero[1];
#define GET_H_ZERO(a1) CPU (h_zero)[a1]
#define SET_H_ZERO(a1, x) (CPU (h_zero)[a1] = (x))
  /* trap enable bit */
  BI h_tebit;
#define GET_H_TEBIT() CPU (h_tebit)
#define SET_H_TEBIT(x) (CPU (h_tebit) = (x))
  /* negative    bit */
  BI h_nbit;
#define GET_H_NBIT() CPU (h_nbit)
#define SET_H_NBIT(x) (CPU (h_nbit) = (x))
  /* zero        bit */
  BI h_zbit;
#define GET_H_ZBIT() CPU (h_zbit)
#define SET_H_ZBIT(x) (CPU (h_zbit) = (x))
  /* overflow    bit */
  BI h_vbit;
#define GET_H_VBIT() CPU (h_vbit)
#define SET_H_VBIT(x) (CPU (h_vbit) = (x))
  /* carry       bit */
  BI h_cbit;
#define GET_H_CBIT() CPU (h_cbit)
#define SET_H_CBIT(x) (CPU (h_cbit) = (x))
  /* prefix      bit */
  BI h_pbit;
#define GET_H_PBIT() CPU (h_pbit)
#define SET_H_PBIT(x) (CPU (h_pbit) = (x))
  /* skip        bit */
  BI h_sbit;
#define GET_H_SBIT() CPU (h_sbit)
#define SET_H_SBIT(x) (CPU (h_sbit) = (x))
  /* window chg  bit */
  BI h_wbit;
#define GET_H_WBIT() CPU (h_wbit)
#define SET_H_WBIT(x) (CPU (h_wbit) = (x))
  /* status register */
  UHI h_status;
#define GET_H_STATUS() nios32bf_h_status_get_handler (current_cpu)
#define SET_H_STATUS(x) \
do { \
nios32bf_h_status_set_handler (current_cpu, (x));\
;} while (0)
  /* prefix register */
  HI h_k;
#define GET_H_K() CPU (h_k)
#define SET_H_K(x) (CPU (h_k) = (x))
  } hardware;
#define CPU_CGEN_HW(cpu) (& (cpu)->cpu_data.hardware)
} NIOS32BF_CPU_DATA;

/* Virtual regs.  */

#define GET_H_M32_GR(index) GET_H_GR_RAW (current_cpu, index)
#define SET_H_M32_GR(index, x) \
do { \
SET_H_GR_RAW (current_cpu, (index), (x));\
;} while (0)
#define GET_H_M32_GR0() GET_H_GR_RAW (current_cpu, 0)
#define SET_H_M32_GR0(x) \
do { \
SET_H_GR_RAW (current_cpu, 0, (x));\
;} while (0)
#define GET_H_M32_BP(index) GET_H_GR_RAW (current_cpu, ((index) + (16)))
#define SET_H_M32_BP(index, x) \
do { \
SET_H_GR_RAW (current_cpu, (((index)) + (16)), (x));\
;} while (0)
#define GET_H_M32_RZ(index) GET_H_GR_RAW (current_cpu, index)
#define SET_H_M32_RZ(index, x) \
do { \
SET_H_GR_RAW (current_cpu, (index), (x));\
;} while (0)
#define GET_H_M32_SP() GET_H_GR_RAW (current_cpu, 14)
#define SET_H_M32_SP(x) \
do { \
SET_H_GR_RAW (current_cpu, 14, (x));\
;} while (0)
#define GET_H_M32_CTL(index) GET_H_CTL_RAW (current_cpu, index)
#define SET_H_M32_CTL(index, x) \
do { \
SET_H_CTL_RAW (current_cpu, (index), (x));\
;} while (0)

/* Cover fns for register access.  */
USI nios32bf_h_pc_get (SIM_CPU *);
void nios32bf_h_pc_set (SIM_CPU *, USI);
UQI nios32bf_h_cwp_get (SIM_CPU *);
void nios32bf_h_cwp_set (SIM_CPU *, UQI);
UQI nios32bf_h_old_cwp_get (SIM_CPU *);
void nios32bf_h_old_cwp_set (SIM_CPU *, UQI);
UQI nios32bf_h_ipri_get (SIM_CPU *);
void nios32bf_h_ipri_set (SIM_CPU *, UQI);
BI nios32bf_h_zero_get (SIM_CPU *, UINT);
void nios32bf_h_zero_set (SIM_CPU *, UINT, BI);
BI nios32bf_h_tebit_get (SIM_CPU *);
void nios32bf_h_tebit_set (SIM_CPU *, BI);
BI nios32bf_h_nbit_get (SIM_CPU *);
void nios32bf_h_nbit_set (SIM_CPU *, BI);
BI nios32bf_h_zbit_get (SIM_CPU *);
void nios32bf_h_zbit_set (SIM_CPU *, BI);
BI nios32bf_h_vbit_get (SIM_CPU *);
void nios32bf_h_vbit_set (SIM_CPU *, BI);
BI nios32bf_h_cbit_get (SIM_CPU *);
void nios32bf_h_cbit_set (SIM_CPU *, BI);
BI nios32bf_h_pbit_get (SIM_CPU *);
void nios32bf_h_pbit_set (SIM_CPU *, BI);
BI nios32bf_h_sbit_get (SIM_CPU *);
void nios32bf_h_sbit_set (SIM_CPU *, BI);
BI nios32bf_h_wbit_get (SIM_CPU *);
void nios32bf_h_wbit_set (SIM_CPU *, BI);
UHI nios32bf_h_status_get (SIM_CPU *);
void nios32bf_h_status_set (SIM_CPU *, UHI);
HI nios32bf_h_k_get (SIM_CPU *);
void nios32bf_h_k_set (SIM_CPU *, HI);
SI nios32bf_h_m32_gr_get (SIM_CPU *, UINT);
void nios32bf_h_m32_gr_set (SIM_CPU *, UINT, SI);
SI nios32bf_h_m32_gr0_get (SIM_CPU *);
void nios32bf_h_m32_gr0_set (SIM_CPU *, SI);
SI nios32bf_h_m32_bp_get (SIM_CPU *, UINT);
void nios32bf_h_m32_bp_set (SIM_CPU *, UINT, SI);
SI nios32bf_h_m32_rz_get (SIM_CPU *, UINT);
void nios32bf_h_m32_rz_set (SIM_CPU *, UINT, SI);
SI nios32bf_h_m32_sp_get (SIM_CPU *);
void nios32bf_h_m32_sp_set (SIM_CPU *, SI);
UHI nios32bf_h_m32_ctl_get (SIM_CPU *, UINT);
void nios32bf_h_m32_ctl_set (SIM_CPU *, UINT, UHI);

/* These must be hand-written.  */
extern CPUREG_FETCH_FN nios32bf_fetch_register;
extern CPUREG_STORE_FN nios32bf_store_register;

typedef struct {
  UINT load_regs;
  UINT load_regs_pending;
} MODEL_NIOS32_1_DATA;

/* Instruction argument buffer.  */

union sem_fields {
  struct { /* no operands */
    int empty;
  } fmt_empty;
  struct { /*  */
    UINT f_i11;
  } sfmt_pfx;
  struct { /*  */
    UINT f_i4w;
  } sfmt_skps32;
  struct { /*  */
    IADDR i_m32_i8v;
  } sfmt_jmpc32;
  struct { /*  */
    IADDR i_rel11;
  } sfmt_bsr32;
  struct { /*  */
    UINT f_i8v;
  } sfmt_save32;
  struct { /*  */
    UINT f_i6v;
  } sfmt_trap32;
  struct { /*  */
    UINT f_i9;
  } sfmt_sts16s;
  struct { /*  */
    UINT f_i10;
  } sfmt_sts8s32;
  struct { /*  */
    UINT f_Ra;
    UINT f_i8;
  } sfmt_lds32;
  struct { /*  */
    IADDR i_m32_i6;
    UINT f_Ra;
  } sfmt_ldc32;
  struct { /*  */
    UINT f_Ra;
    UINT f_Rbi5;
  } sfmt_or32;
  struct { /*  */
    UINT f_Ra;
    USI f_i1;
  } sfmt_ext16s;
  struct { /*  */
    UINT f_Ra;
    UINT f_i2;
  } sfmt_ext8s32;
  struct { /*  */
    UINT f_Ra;
    UINT f_Rb;
  } sfmt_ext16d;
  struct { /*  */
    UINT f_Ra;
    UINT f_Rp;
    UINT f_i5;
  } sfmt_ldp32;
#if WITH_SCACHE_PBB
  /* Writeback handler.  */
  struct {
    /* Pointer to argbuf entry for insn whose results need writing back.  */
    const struct argbuf *abuf;
  } write;
  /* x-before handler */
  struct {
    /*const SCACHE *insns[MAX_PARALLEL_INSNS];*/
    int first_p;
  } before;
  /* x-after handler */
  struct {
    int empty;
  } after;
  /* This entry is used to terminate each pbb.  */
  struct {
    /* Number of insns in pbb.  */
    int insn_count;
    /* Next pbb to execute.  */
    SCACHE *next;
    SCACHE *branch_target;
  } chain;
#endif
};

/* The ARGBUF struct.  */
struct argbuf {
  /* These are the baseclass definitions.  */
  IADDR addr;
  const IDESC *idesc;
  char trace_p;
  char profile_p;
  /* ??? Temporary hack for skip insns.  */
  char skip_count;
  char unused;
  /* cpu specific data follows */
  union sem semantic;
  int written;
  union sem_fields fields;
};

/* A cached insn.

   ??? SCACHE used to contain more than just argbuf.  We could delete the
   type entirely and always just use ARGBUF, but for future concerns and as
   a level of abstraction it is left in.  */

struct scache {
  struct argbuf argbuf;
};

/* Macros to simplify extraction, reading and semantic code.
   These define and assign the local vars that contain the insn's fields.  */

#define EXTRACT_IFMT_EMPTY_VARS \
  unsigned int length;
#define EXTRACT_IFMT_EMPTY_CODE \
  length = 0; \

#define EXTRACT_IFMT_STS8S32_VARS \
  UINT f_op6; \
  UINT f_i10; \
  unsigned int length;
#define EXTRACT_IFMT_STS8S32_CODE \
  length = 2; \
  f_op6 = EXTRACT_LSB0_UINT (insn, 16, 15, 6); \
  f_i10 = EXTRACT_LSB0_UINT (insn, 16, 9, 10); \

#define EXTRACT_IFMT_STS16S_VARS \
  UINT f_op6; \
  UINT f_i9; \
  UINT f_o1; \
  unsigned int length;
#define EXTRACT_IFMT_STS16S_CODE \
  length = 2; \
  f_op6 = EXTRACT_LSB0_UINT (insn, 16, 15, 6); \
  f_i9 = EXTRACT_LSB0_UINT (insn, 16, 9, 9); \
  f_o1 = EXTRACT_LSB0_UINT (insn, 16, 5, 1); \

#define EXTRACT_IFMT_MOVHI_VARS \
  UINT f_op6; \
  UINT f_i5; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_MOVHI_CODE \
  length = 2; \
  f_op6 = EXTRACT_LSB0_UINT (insn, 16, 15, 6); \
  f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_EXT16D_VARS \
  UINT f_op6; \
  UINT f_Rb; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_EXT16D_CODE \
  length = 2; \
  f_op6 = EXTRACT_LSB0_UINT (insn, 16, 15, 6); \
  f_Rb = EXTRACT_LSB0_UINT (insn, 16, 9, 5); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_SEXT16_VARS \
  UINT f_op11; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_SEXT16_CODE \
  length = 2; \
  f_op11 = EXTRACT_LSB0_UINT (insn, 16, 15, 11); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_EXT8S32_VARS \
  UINT f_op9; \
  UINT f_i2; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_EXT8S32_CODE \
  length = 2; \
  f_op9 = EXTRACT_LSB0_UINT (insn, 16, 15, 9); \
  f_i2 = EXTRACT_LSB0_UINT (insn, 16, 6, 2); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_EXT16S_VARS \
  UINT f_op9; \
  USI f_i1; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_EXT16S_CODE \
  length = 2; \
  f_op9 = EXTRACT_LSB0_UINT (insn, 16, 15, 9); \
  f_i1 = ((unsigned int) (EXTRACT_LSB0_UINT (insn, 16, 6, 2)) >> (1)); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_OR32_VARS \
  UINT f_op6; \
  UINT f_Rbi5; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_OR32_CODE \
  length = 2; \
  f_op6 = EXTRACT_LSB0_UINT (insn, 16, 15, 6); \
  f_Rbi5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_LDC32_VARS \
  UINT f_op5; \
  USI f_i6_rel_w; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_LDC32_CODE \
  length = 2; \
  f_op5 = EXTRACT_LSB0_UINT (insn, 16, 15, 5); \
  f_i6_rel_w = ((((EXTRACT_LSB0_UINT (insn, 16, 10, 6)) << (2))) + (((((pc) & (0xfffffffc))) + (4)))); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_LDS32_VARS \
  UINT f_op3; \
  UINT f_i8; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_LDS32_CODE \
  length = 2; \
  f_op3 = EXTRACT_LSB0_UINT (insn, 16, 15, 3); \
  f_i8 = EXTRACT_LSB0_UINT (insn, 16, 12, 8); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_LDP32_VARS \
  UINT f_op4; \
  UINT f_Rp; \
  UINT f_i5; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_LDP32_CODE \
  length = 2; \
  f_op4 = EXTRACT_LSB0_UINT (insn, 16, 15, 4); \
  f_Rp = EXTRACT_LSB0_UINT (insn, 16, 11, 2); \
  f_i5 = EXTRACT_LSB0_UINT (insn, 16, 9, 5); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_TRAP32_VARS \
  UINT f_op8; \
  UINT f_o2; \
  UINT f_i6v; \
  unsigned int length;
#define EXTRACT_IFMT_TRAP32_CODE \
  length = 2; \
  f_op8 = EXTRACT_LSB0_UINT (insn, 16, 15, 8); \
  f_o2 = EXTRACT_LSB0_UINT (insn, 16, 7, 2); \
  f_i6v = EXTRACT_LSB0_UINT (insn, 16, 5, 6); \

#define EXTRACT_IFMT_SAVE32_VARS \
  UINT f_op8; \
  UINT f_i8v; \
  unsigned int length;
#define EXTRACT_IFMT_SAVE32_CODE \
  length = 2; \
  f_op8 = EXTRACT_LSB0_UINT (insn, 16, 15, 8); \
  f_i8v = EXTRACT_LSB0_UINT (insn, 16, 7, 8); \

#define EXTRACT_IFMT_RESTORE32_VARS \
  UINT f_op11; \
  UINT f_Ra; \
  unsigned int length;
#define EXTRACT_IFMT_RESTORE32_CODE \
  length = 2; \
  f_op11 = EXTRACT_LSB0_UINT (insn, 16, 15, 11); \
  f_Ra = EXTRACT_LSB0_UINT (insn, 16, 4, 5); \

#define EXTRACT_IFMT_BSR32_VARS \
  UINT f_op5; \
  USI f_i11_rel; \
  unsigned int length;
#define EXTRACT_IFMT_BSR32_CODE \
  length = 2; \
  f_op5 = EXTRACT_LSB0_UINT (insn, 16, 15, 5); \
  f_i11_rel = ((((((EXTRACT_LSB0_INT (insn, 16, 10, 11)) << (1))) + (pc))) + (2)); \

#define EXTRACT_IFMT_JMPC32_VARS \
  UINT f_op8; \
  USI f_i8v_rel_w; \
  unsigned int length;
#define EXTRACT_IFMT_JMPC32_CODE \
  length = 2; \
  f_op8 = EXTRACT_LSB0_UINT (insn, 16, 15, 8); \
  f_i8v_rel_w = ((((((EXTRACT_LSB0_UINT (insn, 16, 7, 8)) << (1))) + (((pc) + (2))))) & (0xfffffffc)); \

#define EXTRACT_IFMT_SKPS32_VARS \
  UINT f_op11; \
  UINT f_x1; \
  UINT f_i4w; \
  unsigned int length;
#define EXTRACT_IFMT_SKPS32_CODE \
  length = 2; \
  f_op11 = EXTRACT_LSB0_UINT (insn, 16, 15, 11); \
  f_x1 = EXTRACT_LSB0_UINT (insn, 16, 4, 1); \
  f_i4w = EXTRACT_LSB0_UINT (insn, 16, 3, 4); \

#define EXTRACT_IFMT_PFX_VARS \
  UINT f_op5; \
  UINT f_i11; \
  unsigned int length;
#define EXTRACT_IFMT_PFX_CODE \
  length = 2; \
  f_op5 = EXTRACT_LSB0_UINT (insn, 16, 15, 5); \
  f_i11 = EXTRACT_LSB0_UINT (insn, 16, 10, 11); \

/* Collection of various things for the trace handler to use.  */

typedef struct trace_record {
  IADDR pc;
  /* FIXME:wip */
} TRACE_RECORD;

#endif /* CPU_NIOS32BF_H */
