/* collection of junk waiting time to sort out
   Copyright (C) 1998, 1999 Free Software Foundation, Inc.
   Contributed by Cygnus Solutions.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#ifndef NIOS_SIM_H
#define NIOS_SIM_H

/* gdb register numbers */
/* FIXME later */
#define FIRST_GR_REGNUM   0
#define LAST_GR_REGNUM   31
#define PC_REGNUM	 32
#define FIRST_CTL_REGNUM 33
#define LAST_CTL_REGNUM  38

extern UHI nios16bf_h_status_get_handler (SIM_CPU *);
extern void nios16bf_h_status_set_handler (SIM_CPU *, UHI);
extern void nios16bf_h_cwp_set_handler (SIM_CPU *, UQI);
extern void nios16bf_cold_reset (SIM_CPU *, int __userland_p_);
extern UHI nios32bf_h_status_get_handler (SIM_CPU *);
extern void nios32bf_h_status_set_handler (SIM_CPU *, UHI);
extern void nios32bf_h_cwp_set_handler (SIM_CPU *, UQI);
extern void nios32bf_cold_reset (SIM_CPU *, int __userland_p_);


#define GETTWI GETTSI
#define SETTWI SETTSI


/* Hardware/device support.
/* sim_core_attach device argument.  */
extern device nios_devices;

/* FIXME: Temporary, until device support ready.  */
struct _device { int foo; };

#define CURRENT_GREGS(cpu) (& (cpu)->current_regs[0])
#define CURRENT_OREGS(cpu) (& (cpu)->current_regs[8])
#define CURRENT_LREGS(cpu) (& (cpu)->current_regs[16])
#define CURRENT_IREGS(cpu) (& (cpu)->current_regs[24])

/* The register windows are recorded in a seemingly backwards manner.
   %i0-7 live at lower addresses in memory than %o0-7 (even though they
   have higher register numbers).   */

#define REAL_GREGS(cpu) \
  (& (cpu)->global_regs[0])
#define REAL_IREGS(cpu, win) \
  (& (cpu)->win_regs[win][0])
#define REAL_LREGS(cpu, win) \
  (& (cpu)->win_regs[win][8])
#define REAL_OREGS(cpu, win) \
  (& (cpu)->win_regs[(win) - 1][0])

/* Window state.  */

/* Various ways to handle register windows:
   - don't, do all index calculations at runtime
   - table of lookup tables, one entry for each window
   - working copy of registers that is swapped in/out on each
     register window change
   - table of 32 pointers, one for each regs
   - table of 4 pointers, one for each of g,o,l,i regs
   - ???
*/

/* FIXME: Hardcodes number of windows.  */
#define GET_NWINDOWS() NWINDOWS

/* Return the next and previous windows of WIN.
   Note that the next window is win-1 */
#define NEXT_WIN(win) ((win) - 1)
#define PREV_WIN(win) ((win) + 1)

#define HI_WINDOW(wvalid) (((wvalid) & 0x3e0) >> 5)
#define LO_WINDOW(wvalid) ((wvalid) & 0x1f)

/* Return true if window WIN is valid. */
#define WINDOW_VALID_P(win, wvalid) ((win) <= HI_WINDOW(wvalid) && (win) >= LO_WINDOW(wvalid))

/* condition code masks for SKPS instruction */
#define CC_C       0x0
#define CC_NC      0x1
#define CC_Z       0x2
#define CC_NZ      0x3
#define CC_MI      0x4
#define CC_PL      0x5
#define CC_GE      0x6
#define CC_LT      0x7
#define CC_LE      0x8
#define CC_GT      0x9
#define CC_V       0xa
#define CC_NV      0xb
#define CC_LS      0xc
#define CC_HI      0xd

#endif /* NIOS_SIM_H */
