#ifndef REGS32_H
#define REGS32_H

void nios32bf_alloc_regwins (SIM_CPU *, int);
void nios32bf_free_regwins (SIM_CPU *);
void nios32bf_swapout_regwin (SIM_CPU *, int);
void nios32bf_swapin_regwin (SIM_CPU *, int);

void nios32bf_load_regwin (SIM_CPU *, IADDR pc_, int win_);
void nios32bf_reload_regwins (SIM_CPU *);
void nios32bf_flush_regwin (SIM_CPU *, IADDR pc_, int win_, int no_errors_p_);
void nios32bf_flush_regwins (SIM_CPU *, IADDR pc_, int no_errors_p_);

void nios32bf_save_regwin (SIM_CPU *);
void nios32bf_restore_regwin (SIM_CPU *);

void nios32bf_do_save (SIM_CPU *, IADDR pc_, UQI i8v);
void nios32bf_do_restore (SIM_CPU *, IADDR pc_);

int  nios32bf_check_cc_mask (SIM_CPU *, UQI i4w);

#define GET_H_CTL_RAW(cpu, r)  \
  ((r) == 0 ? nios32bf_h_status_get_handler(cpu) : (cpu)->ctl_regs[r])
#define SET_H_CTL_RAW(cpu, r, val) \
  ((r) == 0 ? nios32bf_h_status_set_handler(cpu, val) \
            : ((cpu)->ctl_regs[r] = (val)))

#endif /* REGS32_H */
