/* Main header for the nios.  */

#define USING_SIM_BASE_H /* FIXME: quick hack */

#define NWINDOWS 32

struct _sim_cpu; /* FIXME: should be in sim-basics.h */
typedef struct _sim_cpu SIM_CPU;

/* sim-basics.h includes config.h but cgen-types.h must be included before
   sim-basics.h and cgen-types.h needs config.h.  */
#include "config.h"

#include "symcat.h"
#include "sim-basics.h"
#include "cgen-types.h"
#include "nios-desc.h"
#include "nios-opc.h"
#include "arch.h"

/* These must be defined before sim-base.h.  */
typedef USI sim_cia;

#define CIA_GET(cpu)     CPU_PC_GET (cpu)
#define CIA_SET(cpu,val) CPU_PC_SET ((cpu), (val))

#include "sim-base.h"
#include "cgen-sim.h"
#include "nios-sim.h"

/* hack */
#if defined (WANT_CPU_NIOS16BF)
#include "regs16.h"
#elif defined (WANT_CPU_NIOS32BF)
#include "regs32.h"
#endif


/* The _sim_cpu struct.  */

struct _sim_cpu {
  /* sim/common cpu base.  */
  sim_cpu_base base;

  /* Static parts of cgen.  */
  CGEN_CPU cgen_cpu;

  /* CPU specific parts go here.
     Note that in files that don't need to access these pieces WANT_CPU_FOO
     won't be defined and thus these parts won't appear.  This is ok in the
     sense that things work.  It is a source of bugs though.
     One has to of course be careful to not take the size of this
     struct and no structure members accessed in non-cpu specific files can
     go after here.  Oh for a better language.  */

#if defined (WANT_CPU_NIOS16BF)
 
  NIOS16BF_CPU_DATA cpu_data;
  HI win_regs[NWINDOWS][16];
  /* g0-g7 */
  HI global_regs[2][8];
  /* Working copies of integer regs, swapped in/out on each window change. */
  HI current_regs[32];

#elif defined (WANT_CPU_NIOS32BF)

  NIOS32BF_CPU_DATA cpu_data;
  SI win_regs[NWINDOWS][16];
  /* g0-g7 */
  SI global_regs[2][8];
  /* Working copies of integer regs, swapped in/out on each window change. */
  SI current_regs[32];

#endif

  UHI ctl_regs[6];
};

/* The sim_state struct.  */

struct sim_state {
  sim_cpu *cpu;
#define STATE_CPU(sd, n) (/*&*/ (sd)->cpu)

  CGEN_STATE cgen_state;

  sim_state_base base;
};

/* Misc.  */

/* Catch address exceptions.  */
#ifdef HAVE_CPU_NIOS16BF
extern SIM_CORE_SIGNAL_FN nios16bf_core_signal;
#define SIM_CORE_SIGNAL(SD,CPU,CIA,MAP,NR_BYTES,ADDR,TRANSFER,ERROR) \
nios16bf_core_signal ((SD), (CPU), (CIA), (MAP), (NR_BYTES), (ADDR), \
		  (TRANSFER), (ERROR))
#endif

/* Default memory size.  */
#define NIOS16_DEFAULT_MEM_SIZE 0x20000 /* 128k */
#define NIOS32_DEFAULT_MEM_SIZE 0x80000 /* 512k */

/* Integer register access macros.
   Provides an interface between the cpu description and the register window
   implementation of the day.  To be solidified in time.  */

#define H_CTL_STATUS   0
#define H_CTL_ISTATUS  1
#define H_CTL_WVALID   2

#define H_GR_O0        8
#define H_GR_O1        9
#define H_GR_SP       14
#define H_GR_LINK     15
#define H_GR_FP       30
#define VECBASE_ADDR ((IADDR)0xfc00)

#define GET_H_GR_RAW(cpu, r) ((cpu)->current_regs[r])
#define SET_H_GR_RAW(cpu, r, val) \
  ((cpu)->current_regs[r] = (val))

