/* nios trap definitions
   Copyright (C) 1999 Cygnus Solutions.  */

#ifndef TRAP_H
#define TRAP_H

typedef enum
{
  /* reset */
  TRAP_RESET = 0,
  /* unable to fetch instruction (e.g. bad mapping) */
  TRAP_INSTRUCTION_ACCESS = 1,
  /* illegal instruction */
  TRAP_ILLEGAL_INSN = 2,
  /* priviledged instruction */
  TRAP_PRIVILEDGED_INSN = 3,
  /* FPU disabled */
  TRAP_FP_DIS = 4,
  /* window overflow */
  TRAP_WINDOW_OVERFLOW = 5,
  /* window underflow */
  TRAP_WINDOW_UNDERFLOW = 6,
  /* unaligned memory access */
  TRAP_UNALIGNED_ADDR = 7,
  /* unable to access memory (e.g. bad mapping) */
  TRAP_DATA_ACCESS = 9,

  /* IMPDEP codes used by the simulator in ENVIRONMENT_USER.  */
  TRAP_SIM_UNIMPLEMENTED_OPCODE = 28,
  TRAP_SIM_RESERVED_INSN = 29,
  TRAP_SIM_SPILL = 30,
  TRAP_SIM_FILL = 31,

  /* Traps via the "trap" instruction.  */
  TRAP_INSTRUCTION = 32,			/* n = 0..127 */
  /* System calls.  */
  TRAP_SYSCALL = 32,
  /* trap 1 (32 + 1) is unused */
  /* Divide by zero.  */
  TRAP_DIVIDE_0 = 34,
  /* The breakpoint trap.  */
  TRAP_BREAKPOINT = 35,
  /* Flush register windows.  */
  TRAP_FLUSH_REGWIN = 36,

  TRAP_MAX = 63
} TRAP_TYPE;

#define MAX_NUM_TRAPS	64

#define TRAP_TABLE_SIZE (16 * MAX_NUM_TRAPS)	/* in bytes */

/* The libgloss _exit routine sets a magic number in %o1 to tell us its
   him.  This lets us defer tinkering with libgloss. */
#define LIBGLOSS_EXIT_MAGIC 0xdead


#endif /* TRAP_H */
